<?php
class AuthorFeeds extends Plugin
{
	const VERSION = '1.0';
		
	public function info() {
		return array(
			'name' => 'Author Feeds',
			'version' => self::VERSION,
			'url' => 'http://chrisjdavis.org',
			'author' => 'Chris J. Davis',
			'authorurl' => 'http://chrisjdavis.org',
			'license' => 'Apache License 2.0',
			'description' => 'Grab the feed for a specific author',
			'copyright' => '2008',
			);
	}
	
	public function action_init() {
		//crap to do when the plugin is activated.
	}

	public function filter_rewrite_rules( $rules ) {
		$rules[] = new RewriteRule(array(
			'name' => 'feed',
			'parse_regex' => '/^feed(?:\/(.*?))?$/i',
			'build_str' => 'feed(/{$name})',
			'handler' => 'feedHandler',
			'action' => 'display_feed',
			'priority' => 7,
			'is_active' => 1,
		));

		return $rules;		
	}
	
	function action_update_check() {
		Update::add( 'Author Feeds', '9030c1b0-c1c7-11dd-ad8b-0800200c9a66', self::VERSION ); 
	}
}

class feedHandler extends ActionHandler
{
	public function __construct() {
		$this->theme= Themes::create();
	}
	
	public function act_display_feed() {
		$preproc= strstr( $_SERVER['REQUEST_URI'], 'feed' );
		$explode= explode( '/', $preproc );
		$name= $explode[1];
		echo $this->find( $name );
	}
	
	private function find( $name ) {
		$atom= new AtomHandler();
		$user= User::get($name);
		$posts= Posts::get( array( 'user_id' => $user->id, 'limit' => 5, 'status' => 2 ) );
		
		$xml = $atom->create_atom_wrapper('','','');
		$xml = $atom->add_posts( $xml, $posts );
		$xml = $xml->asXML();

		ob_clean();
		header( 'Content-Type: application/atom+xml' );
		print $xml;
	}
}
?>